//#####################################################################################
//################# Programme panstamp coté utilisateur version 1.0 ###################
//#####################################################################################


#define	SERIAL_SPEED	9600


#include "../source/Arduino.h"
#include "../source/serialcom.h"
#include "../source/cc1101.h"
#include "../source/calibrationMax.h"
#include <util/delay.h>
#include <math.h>
#include <avr/pgmspace.h>


#define  RFCHANNEL 0
#define  SYNCWORD1 0xB5
#define  SYNCWORD0 0x47
#define  SOURCE_ADDR 5
#define  DESTINATION_ADDR 4
#define  LED 3

CCPACKET packettransmit; //paquet de transmission
CCPACKET DemandeCalibration; //demande de calibration
CCPACKET DemandeLecture; // demande de lecture
CCPACKET calibData;//paquet avec courant , tension et temperature demandé
CCPACKET packetrecu; //paquet de reception

byte i;
volatile static boolean OK=false;
volatile static boolean calibok=false;
volatile static boolean data=false;

 CC1101 cc1101;      // radio object


int USART0SendByte(char u8Data, FILE *stream)
{
   if(u8Data == '\n')
   {
      USART0SendByte('\r', 0);
   }
//wait while previous byte is completed
while(!(UCSR0A&(1<<UDRE0))){};
// Transmit data
UDR0 = u8Data;
return 0;
}
int USART0ReceiveByte(FILE *stream)
{
uint8_t u8Data;
// Wait for byte to be received
while(!(UCSR0A&(1<<RXC0))){};
u8Data=UDR0;
//echo input data
USART0SendByte(u8Data,stream);
// Return received data
return u8Data;
}

FILE usart0_str = FDEV_SETUP_STREAM(USART0SendByte, USART0ReceiveByte, _FDEV_SETUP_RW);

void rfPacketReceived(void)
{
  int i;
  CCPACKET packet;
  int cmd;  
  uint8_t sendedChar;
  double v;
  double ii;
  double p;

  float toto;
  float currentt;
  float puiss;

  char voltage[]="tension";
  char courant[]="courant";
  char puissancee[]="puissance";

  // Disable wireless reception interrupt
  detachInterrupt(0);
  _delay_ms(200);
  if(receiveDataCC1101(&packet) > 0)
  {
    cmd=lectcommande(&packet);
    
   
   
   //confirmation packet reçu  
   if(cmd==4)
   {OK=true;
     //affichage port serie
    for(i=1;i<packet.length;i++)
      {
      sendedChar =packet.data[i];
      send_serial(sendedChar);
      } 
   }   
   //confirmation calibration terminée
   if(cmd==5)
   {calibok=true;} 
  
   //data courant tension puissance
   if(cmd==6)
    {
     data=true;
     //affichage des valeurs   
      writeString(voltage);
      toto=calcRealValue(0x00, 0x81,packet.data[7], packet.data[6], packet.data[5]);
      v=(double)toto;
      fprintf(stdout,"%08.3f", v);
      fprintf(stdout,"\n\n");

      writeString(courant);
      currentt=calcRealValue(0x00, 0xBA,  packet.data[10], packet.data[9], packet.data[8]);
      ii=(double)currentt;
      fprintf(stdout,"%06.3f", ii);
      fprintf(stdout,"\n\n");

      writeString(puissancee);
      puiss=calcRealValue(0x00, 0xE1,packet.data[13], packet.data[12], packet.data[11]);
      p=(double)puiss;
      fprintf(stdout,"%08.3f", p);
      fprintf(stdout,"\n\n"); 

     
    }

  }
  // Enable wireless reception interrupt
  attachInterrupt(0, rfPacketReceived, FALLING);
}



int main()

{

char choice; 
char demandecalib[]="Voulez vous calibrer votre Smart Meter? Y-N?\n";


/*############### INITIALISATION #######################*/
// Init RF IC
  initCC1101();
  setChannelCC1101(RFCHANNEL, false);
  setSyncWordCC1101_n3(SYNCWORD1,SYNCWORD0,false);
  setDevAddressCC1101(SOURCE_ADDR, false);
  disableAddressCheck();
  init_serial(SERIAL_SPEED);//initialisation du port serie matériel 
  stdin=stdout=&usart0_str;
  

  sei();
  attachInterrupt(0, rfPacketReceived, FALLING);


  writeString(demandecalib); //demande de calibration
  choice=getByte();


if(choice==0x59)//procedure de calibration
{
 calibData.length=7;
 calibData.data[0]=DESTINATION_ADDR;
 calibData.data[7]='0';

 datacalibration(&calibData);//constitution des valeurs courant, tension, température pour la calibration
}


while(1)
{
   tramelecture(DESTINATION_ADDR);
   _delay_ms(400);
   while(OK==false)
    { 
      tramelecture(DESTINATION_ADDR);
      _delay_ms(400);
    }
    
    OK=false;


   while(data==false)
   {
  
   }

   data=false;
   
   _delay_ms(1000);
}


return 1;
}
