//#####################################################################################
//################# Programme panstamp coté Smart Meter version 1.0 ###################
//#####################################################################################


#include "../source/EEPROM.h"
#include "../source/cc1101.h"
#include "../source/serialcom.h"
#include "../source/calibrationMax.h"

   
#define RFCHANNEL        0       // Let's use channel 0
#define SYNCWORD1        0xB5    // Synchronization word, high byte
#define SYNCWORD0        0x47    // Synchronization word, low byte
#define SOURCE_ADDR      4       // Sender address
#define DESTINATION_ADDR 5       // Receiver address
#define SERIAL_SPEED  9600

CC1101 cc1101;      // radio object
byte count = 0;
volatile static boolean cmdCALIB=false;
volatile static boolean cmdLECT=false;
volatile static boolean cmdACCUM=false;
volatile static boolean valuesok=false;
MPACKET masterpacket;
SPACKET slavepacket;
CALIBPacket valuecalib;
MPACKET masterpacketlect;
SPACKET slavepacketlect;


/**
 * This function is called whenever a wireless packet is received
 */
void rfPacketReceived(void)
{
  CCPACKET packet;
  int cmd;  
  // Disable wireless reception interrupt
  detachInterrupt(0);
  _delay_ms(200);
 
  if(receiveDataCC1101(&packet) > 0)
  {
    cmd=lectcommande(&packet); 
    //Demande de calibration
    if(cmd==1)
    {cmdCALIB=true;
     valuecalib.current =packet.data[6]; //courant
     valuecalib.voltage =packet.data[7]; //tension 
     valuecalib.temp=packet.data[8];     //température
    }
    //Demande de lecture des registres VRMS,IRMS et PRMS
    if(cmd==2)
    {cmdLECT=true;}
    //Demande de lecture de la puissance sur 1 minute
    if(cmd==3)
    {cmdACCUM=true;}  
  }
  // Enable wireless reception interrupt
  attachInterrupt(0, rfPacketReceived, FALLING);
}   



int main() 
{
  
  DDRD |=_BV(PD7);
  PORTD &=~(_BV(PD7));
   _delay_ms(500);
  PORTD |=_BV(PD7); 
  _delay_ms(500);
  DDRD |=_BV(PD0);
  PORTD |=_BV(PD0);
  

  // Init RF IC
  initCC1101();
  setChannelCC1101(RFCHANNEL, false);
  setSyncWordCC1101_n3(SYNCWORD1,SYNCWORD0,false);
  setDevAddressCC1101(SOURCE_ADDR, false);
  disableAddressCheck();
  
  init_serial(SERIAL_SPEED);//initialisation du port serie matériel 
  sw_uart_init(); //initialisation du port serie logiciel
  
  cmdCALIB=false;
  cmdLECT=false;
  cmdACCUM=false;
  valuesok=false;

  sei();
  attachInterrupt(0, rfPacketReceived, FALLING);


    while(1)
  {
    //###################CALIBRATION##################### 
    if(cmdCALIB==true)
    {    
      cmdCALIB=false;
      AnswerSlave();//repond OK comme acknowledge
      //fonctions de calibration
      calibrationprocess(&masterpacket,&slavepacket,&valuecalib);
      //envoi confirmation de calibration à l'utilisateur
      trameconfirmationcalibration();  
    }
    
    //####################LECTURE TENSION,COURANT,PUISSANCE##############
    if(cmdLECT==true)
    {
      cmdLECT=false;
      AnswerSlave();//repond OK comme acknowledge
      //fonctions de lectures et envoi des données en RF 
      lectureMaxim(&masterpacketlect,&slavepacketlect);
    }

    //###################LECTURE PUISSANCE 1MINUTE######################
    if(cmdACCUM==true)
    {
      cmdACCUM=false;
      AnswerSlave();
    //fonctions puissance 1minute  
    }

  }
return 1;  
}