#include "calibrationMax.h"
#include <assert.h>
#include <stdint.h>

//permet de construire la trame à envoyer du panstamp vers le maxim via le softuart
void trame_master_select(MPACKET *masterpacket, uint8_t commande, uint16_t WordAddr, uint8_t commande2, uint8_t *ValueArray)
{

        masterpacket->header=HEADMASTER;
        masterpacket->payload=commande;

          if(WordAddr>0xFF) //si l'adresse est supérieur à 1 octet
            {
            masterpacket->Ladresse=(uint8_t)(WordAddr & 0x00FF);
            masterpacket->Hadresse=(uint8_t)((WordAddr & 0xFF00) >> 8);
            }
          else
          { 
            masterpacket->Ladresse=(uint8_t)(WordAddr & 0x00FF);
            masterpacket->Hadresse=0x00;
          }

        if(commande2==ECRITURECOMMANDE)
        {masterpacket->count=0x0A; 
            masterpacket->data1=ValueArray[0];
            masterpacket->data2=ValueArray[1];
            masterpacket->data3=ValueArray[2];
         masterpacket->com2=commande2;
         masterpacket->checksum= 256-((masterpacket->header + masterpacket->count + masterpacket->payload + masterpacket->Ladresse + masterpacket->Hadresse + masterpacket->data1 + masterpacket->data2 + masterpacket->data3 + masterpacket->com2)%256);
        }
        if(commande2==LECTURECOMMANDE)
        {masterpacket->count=0x07;
         masterpacket->com2=commande2;
         masterpacket->checksum= 256-((masterpacket->header + masterpacket->count + masterpacket->payload + masterpacket->Ladresse + masterpacket->Hadresse + masterpacket->com2)%256);
        }

}



//envoi de la trame constituée precedement (avec la fonction trame_master_select) vers le maxim 
void Send_master(MPACKET *masterpacket)
{

sw_UART_Transmit_char(masterpacket->header);
sw_UART_Transmit_char(masterpacket->count);
sw_UART_Transmit_char(masterpacket->payload);

            sw_UART_Transmit_char(masterpacket->Ladresse);//All multibyte payloads are sent and received least-significant-byte first. 
            sw_UART_Transmit_char(masterpacket->Hadresse);    

    if(masterpacket->com2==LECTURECOMMANDE)     
    {sw_UART_Transmit_char(masterpacket->com2);}
     
    if(masterpacket->com2==ECRITURECOMMANDE)
    { sw_UART_Transmit_char(masterpacket->com2);
      sw_UART_Transmit_char(masterpacket->data1);
      sw_UART_Transmit_char(masterpacket->data2);
      sw_UART_Transmit_char(masterpacket->data3);  
    }   
    
sw_UART_Transmit_char(masterpacket->checksum);    

}

//attente d'un acknowledge sans data 
boolean wait_acknowledge_without_data(SPACKET *slavepacket)
{
uint8_t acknow=0x00;

while( (acknow!=0xAA) && (acknow!=0xAB) && (acknow!=0xB0) && (acknow!=0xBC) & (acknow!=0xBD) && (acknow!=0xBF) && (acknow!=0xAD)) 
    {acknow=sw_UART_Receive_char();}

slavepacket->acknowledge=acknow;

if(acknow==0xAD)
    { return true;}
else
    {return false;}

}

//attente d'un acknowledge avec une trame de data 
boolean wait_acknowledge_and_data(SPACKET *slavepacket)
{
uint8_t acknow=0x00;

while( (acknow!=0xAA) && (acknow!=0xAB) && (acknow!=0xB0) && (acknow!=0xBC) & (acknow!=0xBD) && (acknow!=0xBF) && (acknow!=0xAD)) 
    {acknow=sw_UART_Receive_char();}

slavepacket->acknowledge=acknow;

if( (acknow==0xAA) || (acknow==0xAB) )
    { return true;}
else
    {return false;}

}


//Permet de récéptionner les trames en provenance du maxim (avec data) 
void receiv_master(SPACKET *slavepacket)
{
 slavepacket->count=sw_UART_Receive_char();
 slavepacket->data1=sw_UART_Receive_char();  
 slavepacket->data2=sw_UART_Receive_char(); 
 slavepacket->data3=sw_UART_Receive_char();  
 slavepacket->checksum=sw_UART_Receive_char();
}

//fonction utilisé pour debugger 
void affichagetrame(SPACKET *slavepacket)
{
  
    
/*//used for debug
send_serial(slavepacket->acknowledge);
send_serial(slavepacket->count);

//(uint8_t)(slavepacket->data & 0x000000FF);
send_serial(slavepacket->data1);

//(uint8_t)( (slavepacket->data & 0x0000FFFF)>>8);
send_serial(slavepacket->data2);


//tampon=slavepacket->data3;//(uint8_t)((slavepacket->data & 0x00FFFFFF)>>16);
send_serial(slavepacket->data3);

send_serial(slavepacket->checksum);
*/

send_serial(slavepacket->data1);    

send_serial(slavepacket->data2);

send_serial(slavepacket->data3);

}

//Configuration des valeurs Vtarget, Itarget, Ttarget pour le processus de calibration 
void targetvalue(MPACKET *masterpacket,SPACKET *slavepacket,CALIBPacket *valuecalib)
{
  uint8_t bytesV[4];
  uint8_t voltage[3];
  uint8_t bytesI[4];
  uint8_t current[3];
  uint8_t bytesT[4];
  uint8_t temperature[3];

 
//############### tension ####################
float V = (float)valuecalib->voltage /(2* FSV);
memcpy(bytesV, &V, 4);
uint8_t tamponV0=bytesV[0]; uint8_t tamponV1=bytesV[1]; uint8_t tamponV2=bytesV[2];
tamponV2=tamponV2 &0x7F;   tamponV2=tamponV2|0x80;
uint32_t trameV=(((uint32_t)0x00 << 24) | ((uint32_t)tamponV2 << 16) | ((uint32_t)tamponV1 << 8) | (uint32_t)tamponV0);

       voltage[0]= (uint8_t)( (trameV>>2) & 0x000000FF);
       voltage[1]= (uint8_t)(((trameV>>2) & 0x0000FF00)>>8);
       voltage[2]= (uint8_t)(((trameV>>2) & 0x00FF0000)>>16);
        

//############### courant ####################
float I = (float)valuecalib->current /(2 * FSI);
memcpy(bytesI, &I, 4);
uint8_t tamponI0=bytesI[0]; uint8_t tamponI1=bytesI[1]; uint8_t tamponI2=bytesI[2]; 
tamponI2=tamponI2 &0x7F;   tamponI2=tamponI2|0x80;
//current[0]=tamponI0; current[1]=tamponI1; current[2]=tamponI2;
uint32_t trameI=(((uint32_t)0x00 << 24) | ((uint32_t)tamponI2 << 16) | ((uint32_t)tamponI1 << 8) | (uint32_t)tamponI0);

       current[0]= (uint8_t)( (trameI>>2) & 0x000000FF);
       current[1]= (uint8_t)(((trameI>>2) & 0x0000FF00)>>8);
       current[2]= (uint8_t)(((trameI>>2) & 0x00FF0000)>>16);


//############## température #################
float T = (float)valuecalib->temp; 
memcpy(bytesT, &T, 4);
uint8_t tamponT0=bytesT[0]; uint8_t tamponT1=bytesT[1]; uint8_t tamponT2=bytesT[2];
tamponT2=tamponT2 &0x7F;   tamponT2=tamponT2|0x80;
temperature[0]=tamponT0; temperature[1]=tamponT1; temperature[2]=tamponT2;
uint32_t trameT=(((uint32_t)0x00 << 24) | ((uint32_t)tamponT2 << 16) | ((uint32_t)tamponT1 << 8) | (uint32_t)tamponT0);

       temperature[0]= (uint8_t)(   (trameT>>2) & 0x000000FF);
       temperature[1]= (uint8_t)(((trameT>>2) & 0x0000FF00)>>8);
       temperature[2]= (uint8_t)(((trameT>>2) & 0x00FF0000)>>16);

//########## Consitution et envoi des trames #################
trame_master_select(masterpacket, POINTERSELECTION, ADDRVTARGET,ECRITURECOMMANDE,voltage); // constitution de la trame de calibration 
 Send_master(masterpacket); //envoie de la trame de calibration  VTARGET  
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 


 trame_master_select(masterpacket, POINTERSELECTION, ADDRITARGET,ECRITURECOMMANDE,current); // constitution de la trame de calibration 
 Send_master(masterpacket); //envoie de la trame de calibration  ITARGET
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 

trame_master_select(masterpacket, POINTERSELECTION, ADDRT_TARGET,ECRITURECOMMANDE,temperature); // constitution de la trame de calibration 
Send_master(masterpacket); //envoie de la trame de TEMPERATURE TARGET   
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 

}

//Processus de calibration
void calibrationprocess(MPACKET *masterpacket,SPACKET *slavepacket,CALIBPacket *valuecalib)
{
 
 uint8_t configregister[3];
 uint8_t calibcommandeGain[3];
 uint8_t flashcommande[3];       
 uint8_t softreset[3];
 uint8_t calibcommandeOffset[3];
 uint8_t Vscale[3];
 uint8_t Iscale[3];

        //valeur fixe Vscale 
        Vscale[0]=0x9B; 
        Vscale[1]=0x02;
        Vscale[2]=0x00;
        //valeur fixe Iscale
        Iscale[0]=0x3F; 
        Iscale[1]=0x00;  
        Iscale[2]=0x00;
        //commande calibration gain
        calibcommandeGain[0]=0x20; 
        calibcommandeGain[1]=0x28;
        calibcommandeGain[2]=0xCA;
        //commande calibration offset
        calibcommandeOffset[0]=0x20;
        calibcommandeOffset[1]=0x2A;
        calibcommandeOffset[2]=0xCA;
        // commande save to flash memory
        flashcommande[0]=0x20;
        flashcommande[1]=0xC2;
        flashcommande[2]=0xAC; 
        //commande reset logiciel
        softreset[0]=0x00; 
        softreset[1]=0x00;
        softreset[2]=0xBD;    
        //valeur du registre config fixe
        configregister[0]=0x56; 
        configregister[1]=0x56;
        configregister[2]=0x05;
    
CCPACKET packetok;
//acknoledge packet
packetok.length=4;
packetok.data[0]=5; // adresse de destination
packetok.data[1]=0x4F; //O
packetok.data[2]=0x4B; //K
packetok.data[3]='0';

//################################### CALIBRATION GAIN ##############################################################################
 trame_master_select(masterpacket, POINTERSELECTION, ADDRCONFIG,ECRITURECOMMANDE,configregister); // constitution de la trame de calibration 
 Send_master(masterpacket); //envoie de la trame de calibration  CONFIG  
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 

 trame_master_select(masterpacket, POINTERSELECTION, ADDRVFSCALE,ECRITURECOMMANDE,Vscale); // constitution de la trame de calibration 
 Send_master(masterpacket); //envoie de la trame de calibration  VSCALE  
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 
 
 trame_master_select(masterpacket, POINTERSELECTION, ADDRIFSCALE,ECRITURECOMMANDE,Iscale); // constitution de la trame de calibration 
 Send_master(masterpacket); //envoie de la trame de calibration  ISCALE  
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 

// premier acknowledge de calibration envoyé à l'utilisateur
  sendDataCC1101(packetok);
      _delay_ms(200);

//valeurs Vtarget, Itarget, Ttarget
targetvalue(masterpacket,slavepacket,valuecalib);

// deuxiéme acknowledge de calibration envoyé à l'utilisateur
sendDataCC1101(packetok);
      _delay_ms(200);

trame_master_select(masterpacket, POINTERSELECTION, ADDRCOMMANDE,ECRITURECOMMANDE,flashcommande); // constitution de la trame de calibration 
Send_master(masterpacket); //envoie de la trame COMMANDE FLASH    
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 

/*trame_master_select(masterpacket, POINTERSELECTION, ADDRCOMMANDE,ECRITURECOMMANDE,softreset); // constitution de la trame de calibration 
Send_master(masterpacket); //envoie de la trame COMMANDE SOFTRESET    
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);}*/ 

PORTD &=~(_BV(PD0));  //hard reset
_delay_ms(500);
PORTD |=_BV(PD7); 
//troisiéme acknowledge de calibration envoyé à l'utilisateur
sendDataCC1101(packetok);
      _delay_ms(200);

trame_master_select(masterpacket, POINTERSELECTION, ADDRCOMMANDE,ECRITURECOMMANDE,calibcommandeGain); // constitution de la trame de calibration 
Send_master(masterpacket); //envoie de la trame COMMANDE CALIBRATION GAIN     
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 

//quatriéme acknowledge de calibration envoyé à l'utilisateur
    sendDataCC1101(packetok);
      _delay_ms(200);
          
trame_master_select(masterpacket, POINTERSELECTION, ADDRCOMMANDE,ECRITURECOMMANDE,flashcommande); // constitution de la trame de calibration 
Send_master(masterpacket); //envoie de la trame COMMANDE FLASH    
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 

/*trame_master_select(masterpacket, POINTERSELECTION, ADDRCOMMANDE,ECRITURECOMMANDE,softreset); // constitution de la trame de calibration 
Send_master(masterpacket); //envoie de la trame COMMANDE SOFTRESET    
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);}*/

  PORTD &=~(_BV(PD0));  //hard reset
  _delay_ms(500);
  PORTD |=_BV(PD7); 
 

//################################CALIBRATION OFFSET##############################################################
trame_master_select(masterpacket, POINTERSELECTION, ADDRCOMMANDE,ECRITURECOMMANDE,calibcommandeOffset); // constitution de la trame de calibration 
Send_master(masterpacket); //envoie de la trame COMMANDE OFFSET     
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 
        

trame_master_select(masterpacket, POINTERSELECTION, ADDRCOMMANDE,ECRITURECOMMANDE,flashcommande); // constitution de la trame de calibration 
Send_master(masterpacket); //envoie de la trame COMMANDE FLASH    
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} 

/*trame_master_select(masterpacket, POINTERSELECTION, ADDRCOMMANDE,ECRITURECOMMANDE,softreset); // constitution de la trame de calibration 
Send_master(masterpacket); //envoie de la trame COMMANDE SOFTRESET    
while(wait_acknowledge_without_data(slavepacket)==false) //attente d'un acknowledge sans data si l'acknowledge est une erreur alors je renvoi ma trame
      { Send_master(masterpacket);} */

   PORTD &=~(_BV(PD0));  //hard reset
  _delay_ms(500);
  PORTD |=_BV(PD7);     

}


uint32_t floatToInt32(float *value)
{
    return *((uint32_t*)value);
}

uint8_t *getBytesValue(size_t value)
{
    int _cpt;
    size_t _size = sizeof(value);
    uint8_t *_bytesArray = (uint8_t*) malloc(_size*sizeof(uint8_t));

    for (_cpt = 0; _cpt < _size; _cpt++)
        _bytesArray[_cpt] = (value >> 8*_cpt) & 0xff;

    
    return _bytesArray;
}

float calcRealValue(uint8_t HByteaddress, uint8_t LByteAddress, uint8_t HByteValue, uint8_t MByteValue, uint8_t LByteValue)
{
    uint16_t _address = ((uint16_t)HByteaddress << 8 | LByteAddress);
    uint32_t tmp = ((uint32_t)HByteValue << 16 | (uint32_t)MByteValue << 8 | (uint32_t)LByteValue);
    float _value = (float)tmp;


    switch (_address)
    {
    case VA:
        /*calculation for VA*/
        _value = (_value / pow(2, 23))* FSV;
            break;
    case IA:
        /*calculation for IA*/
        _value = (_value / pow(2, 23))* FSI;
        break;
    case VA_RMS:
        /*calculation for VA_RMS*/
         _value = (_value / pow(2, 23))* FSV;
        break;
    case IA_RMS:
        /*calculation for IA_RMS*/
        _value = (_value / pow(2, 23))* FSI;
        break;
    case WATT_A:
        /*calculation for WATT_A*/
        _value = (_value / pow(2, 23))* FSP;
        break;
    case VAR_A:
        /*calculation for VAR_A*/
        _value = (_value / pow(2, 23))* FSP;
        break;
    case VA_A:
        /*calculation for VA_A*/
        _value = (_value / pow(2, 23))* FSP;
        break;
    case PFA:
        /*calculation for PFA*/
        _value = (_value / pow(2, 23))* FSP;
        break;
    case TEMPC:
        /*calculation for TEMPC*/
        //I don't know for the moment
        break;
    case PA_POS_CNT:
        //Calculation for energy - INT type, so no need calculation
        break;
    default:
        //An error occured
        exit(1);
        break;
    }

    return _value;
}


//Permet de demander les valeurs VRMS, IRMS ,PRMS via le softserial vers le maxim (panstamp escalve)
void lectureMaxim(MPACKET *masterpacket,SPACKET *slavepacket)
{
    uint8_t tampon[3]={0};
    uint8_t data[10]={0};



    //####### LECTURE VARMS #############
trame_master_select(masterpacket, POINTERSELECTION, VA_RMS,LECTURECOMMANDE,tampon); // constitution de la trame de lecture
Send_master(masterpacket); //envoie de la trame de lecture VARMS 
while (wait_acknowledge_and_data(slavepacket)==false) //attente d'un acknowledge avec data si l'acknowledge est une erreur alors je renvoi ma trame
    {Send_master(masterpacket);} 
receiv_master(slavepacket);

 data[0]= slavepacket->data1; data[1] = slavepacket->data2; data[2] = slavepacket->data3;



//####### LECTURE IARMS #############
trame_master_select(masterpacket, POINTERSELECTION, IA_RMS,LECTURECOMMANDE,tampon); // constitution de la trame de lecture
Send_master(masterpacket); //envoie de la trame de lecture IARMS 
while (wait_acknowledge_and_data(slavepacket)==false) //attente d'un acknowledge avec data si l'acknowledge est une erreur alors je renvoi ma trame
    {Send_master(masterpacket);} 
receiv_master(slavepacket);

data[3] = slavepacket->data1; data[4] = slavepacket->data2; data[5] = slavepacket->data3;


//####### LECTURE WATTA puissance active #############
trame_master_select(masterpacket, POINTERSELECTION, WATT_A,LECTURECOMMANDE,tampon); // constitution de la trame de lecture
Send_master(masterpacket); //envoie de la trame de lecture IARMS 
while (wait_acknowledge_and_data(slavepacket)==false) //attente d'un acknowledge avec data si l'acknowledge est une erreur alors je renvoi ma trame
    {Send_master(masterpacket);} 
receiv_master(slavepacket);

data[6] = slavepacket->data1; data[7] = slavepacket->data2; data[8] = slavepacket->data3;



envoiDATA(data);

}