#include "serialcom.h"

void init_serial(int speed)
{
/* Set baud rate */
//UBRR0 = CPU_FREQ/(((unsigned long int)speed)<<4)-1;

UBRR0H = (uint8_t)(BAUD_PRESCALLER>>8);
UBRR0L = (uint8_t)(BAUD_PRESCALLER);

/* Enable transmitter */
//UCSR0B = (1<<TXEN0);
 UCSR0B = _BV(RXEN0) | _BV(TXEN0);   /* Enable RX and TX */

/* Set 8 bits character and 1 stop bit */
UCSR0C = (1<<UCSZ01 | 1<<UCSZ00);

/* Set off UART baud doubler */
//UCSR0A &= ~(1 << U2X0);
}


void send_serial(uint8_t c)
{
loop_until_bit_is_set(UCSR0A, UDRE0);
UDR0 = c;

	/*if ((c!=0x0a) && (c!=0x0d))
	{
	send_serial(0x0a);
	send_serial(0x0d);
	}
*/
}

void putByte(unsigned char data)
{
// Stay here until data buffer is empty
while (!(UCSR0A & _BV(UDRE0)));
UDR0 = (unsigned char) data;
 
} 

uint8_t receive_serial(uint8_t ReceivedChar)
{
 while ( !(UCSR0A & (1 << RXC0)) );  // Wait until data is received
 ReceivedChar = UDR0;               // Read the data from the RX buffer

return ReceivedChar; 

}

void writeString(char *str)
{
	  while (*str != '\0')
	{
	  putByte(*str);
	  ++str;
	}
	send_serial(0x0d);
} 


uint8_t getByte(void)
{
// Check to see if something was received
while (!(UCSR0A & _BV(RXC0)));
return (uint8_t) UDR0;
} 

const char* readString(void)
{
static char rxstr[RX_BUFF];
static char* temp;
temp = rxstr;
 
	while((*temp = getByte()) != '\n')
	{
	++temp;
	}
 
return rxstr;
} 

