/**
 * Copyright (c) 2011 Daniel Berenguer <dberenguer@usapiens.com>
 * 
 * This file is part of the panStamp project.
 * 
 * panStamp  is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 * 
 * panLoader is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with panLoader; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 
 * USA
 * 
 * Author: Daniel Berenguer
 * Creation date: 03/03/2011
 */

#include "spi.h"

/**
 * init
 * 
 * SPI initialization
 */
void initspi()
{
   PORTB |=_BV(PB2);//digitalWrite(SPI_SS, HIGH);
  
 // Configure SPI pins
 DDRB |=_BV(PB2);// pinMode(SPI_SS, OUTPUT);
 DDRB |=_BV(PB3); // pinMode(SPI_MOSI, OUTPUT);
 DDRB &=~(_BV(PB4));// pinMode(SPI_MISO, INPUT);
 DDRB |=_BV(PB5);// pinMode(SPI_SCK, OUTPUT);

  PORTB |=_BV(PB5);// digitalWrite(SPI_SCK, HIGH);
 PORTB &=~(_BV(PB3));// digitalWrite(SPI_MOSI, LOW);

  // SPI speed = clk/4
  SPCR = _BV(SPE) | _BV(MSTR);
}

/**
 * send
 * 
 * Send byte via SPI
 * 
 * 'value'	Value to be sent
 * 
 * Return:
 * 	Response received from SPI slave
 */
byte sendspi(byte value) 
{
  SPDR = value;                          // Transfer byte via SPI
  wait_Spi();                            // Wait until SPI operation is terminated

  return SPDR;
}

